package org.websparrow;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.CommandLineRunner;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.websparrow.dto.Employee;
import org.websparrow.repository.EmployeeRepository;

import java.util.List;

@SpringBootApplication
public class SpringBootMongoDBApp implements CommandLineRunner {

    public static void main(String[] args) {
        SpringApplication.run(SpringBootMongoDBApp.class, args);
    }

    @Autowired
    private EmployeeRepository employeeRepository;

    @Override
    public void run(String... args) throws Exception {

        // Save the employees
        employeeRepository.save(new Employee("Atul", "Rai", 'M', 28));
        employeeRepository.save(new Employee("Pallavi", "Tripathi", 'F', 25));
        employeeRepository.save(new Employee("Manish", "Fartiyal", 'M', 30));
        employeeRepository.save(new Employee("Lucifer", "**", 'F', 33));

        // Fetch the all employees
        List<Employee> employees = employeeRepository.findAll();
        System.out.println("============ List of all employees ============");
        System.out.println(employees);

        // Fetch the all employees by first name
        List<Employee> employeesByFirstName = employeeRepository.findByFirstName("Manish");
        System.out.println("============ List of all employees by first name ============");
        System.out.println(employeesByFirstName);

        // Fetch the all employees by gender
        List<Employee> employeesByGender = employeeRepository.findByGender('F');
        System.out.println("============ List of all employees by gender ============");
        System.out.println(employeesByGender);

    }
}
